// Generated by CoffeeScript 1.10.0
(function() {
  var AttributeDescription, AttributeType, CoreData, EntityDescription, ManagedObject, ManagedObjectContext, ManagedObjectModel, PersistentStoreCoordinator, Pool, Predicate, Q, RelationshipDescription, async, url;

  PersistentStoreCoordinator = require('./lib/PersistentStoreCoordinator');

  ManagedObjectModel = require('./lib/ManagedObjectModel');

  ManagedObjectContext = require('./lib/ManagedObjectContext');

  ManagedObject = require('./lib/ManagedObject');

  Predicate = require('./lib/FetchClasses/Predicate');

  EntityDescription = require('./lib/Descriptors/EntityDescription');

  AttributeDescription = require('./lib/Descriptors/AttributeDescription');

  AttributeType = require('./lib/Descriptors/AttributeType');

  RelationshipDescription = require('./lib/Descriptors/RelationshipDescription');

  Pool = require('generic-pool');

  url = require('url');

  async = require('async');

  Q = require('q');

  CoreData = (function() {
    CoreData.registerType = function(type) {
      return AttributeDescription.registerType(type);
    };

    function CoreData(storeURL, options1) {
      this.storeURL = storeURL;
      this.options = options1 != null ? options1 : {};
      if (this.options.logging === void 0) {
        this.options.logging = console.log;
      }
      this.model = new ManagedObjectModel(this.options.modelFile, this.options.modelClasses);
    }

    CoreData.prototype.syncSchema = function(options, callback) {
      var deferred;
      deferred = Q.defer();
      if (typeof options === 'function') {
        callback = options;
        options = void 0;
      }
      options = options || {};
      async.forEach(this._persistentStoreCoordinator().persistentStores, function(store, cb) {
        return store.syncSchema(options, cb);
      }, function(err) {
        if (err) {
          return deferred.reject(err);
        } else {
          return deferred.resolve();
        }
      });
      return deferred.promise.nodeify(callback);
    };

    CoreData.prototype.defineEntity = function(entityName, attributes, options) {
      var entity;
      if (options == null) {
        options = {};
      }
      options.columns = attributes;
      entity = new EntityDescription(entityName, options);
      this.model.addEntity(entity);
      return entity;
    };

    CoreData.prototype.defineRelationship = function(entity, destinationEntity, name, options) {
      var relationship;
      if (options == null) {
        options = {};
      }
      if (typeof entity === 'string') {
        entity = this.model.entities[entity];
      }
      if (typeof destinationEntity === 'string') {
        destinationEntity = this.model.entities[destinationEntity];
      }
      relationship = new RelationshipDescription(name, destinationEntity, options.toMany, options.inverse, entity);
      return entity.addRelationship(relationship);
    };

    CoreData.prototype.createContext = function() {
      return new ManagedObjectContext(this._persistentStoreCoordinator());
    };

    CoreData.prototype._persistentStoreCoordinator = function() {
      if (!this.persistentStoreCoordinator) {
        this.persistentStoreCoordinator = new PersistentStoreCoordinator(this.model, this.options);
        this.persistentStoreCoordinator.addStore(this.storeURL);
      }
      return this.persistentStoreCoordinator;
    };

    CoreData.prototype.middleware = function() {
      return (function(_this) {
        return function(req, res, next) {
          var context;
          context = _this.createContext();
          req.context = context;
          res.once('finish', function() {
            return context.destroy();
          });
          return next();
        };
      })(this);
    };

    return CoreData;

  })();

  CoreData.PersistentStoreCoordinator = PersistentStoreCoordinator;

  CoreData.ManagedObjectModel = ManagedObjectModel;

  CoreData.ManagedObjectContext = ManagedObjectContext;

  CoreData.ManagedObject = ManagedObject;

  CoreData.Predicate = Predicate;

  CoreData.AttributeType = AttributeType;

  CoreData.debug = process.env.NOD_ENV !== 'production';

  module.exports = CoreData;

}).call(this);
