// Generated by CoffeeScript 1.10.0
(function() {
  var EntityDescription, ManagedObject, ManagedObjectModel, fs, path, util,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  EntityDescription = require('./Descriptors/EntityDescription');

  ManagedObject = require('./ManagedObject');

  path = require('path');

  fs = require('fs');

  util = require('util');

  ManagedObjectModel = (function(superClass) {
    extend(ManagedObjectModel, superClass);

    function ManagedObjectModel(scheme, modelClasses) {
      if (scheme == null) {
        scheme = null;
      }
      this.entities = {};
      this.classes = {};
      this.modelClasses = modelClasses || {};
      if (scheme) {
        if (fs.existsSync(scheme)) {
          this.loadSchemeFromUrl(scheme);
        } else {
          this.loadSchemeFromYaml(scheme);
        }
      }
    }

    ManagedObjectModel.prototype.loadSchemeFromUrl = function(url) {
      var entity, ext, key, ref, results;
      ext = path.extname(url);
      switch (ext) {
        case '.yaml':
          require('./Parsers/ModelYamlParser').fillModelFromYamlFile(this, url);
          break;
        default:
          throw new Error('unknown extension ' + ext);
      }
      ref = this.entities;
      results = [];
      for (key in ref) {
        entity = ref[key];
        results.push(this._entityObjectClass(entity));
      }
      return results;
    };

    ManagedObjectModel.prototype.loadSchemeFromYaml = function(yamlSource) {
      var entity, key, ref, results;
      require('./Parsers/ModelYamlParser').fillModelFromYaml(this, yamlSource);
      ref = this.entities;
      results = [];
      for (key in ref) {
        entity = ref[key];
        results.push(this._entityObjectClass(entity));
      }
      return results;
    };

    ManagedObjectModel.prototype.addEntity = function(entity) {
      if (entity instanceof EntityDescription) {
        return this.entities[entity.name] = entity;
      } else {
        throw Error('entity ' + entity + ' is not EntityDescription');
      }
    };

    ManagedObjectModel.prototype.getEntity = function(entityName) {
      return this.entities[entityName];
    };

    ManagedObjectModel.prototype.subclassForEntity = function(entityName) {
      var Subclass, attribute, entity, i, j, len, len1, objectClass, ref, ref1, relationship;
      entity = this.entities[entityName];
      Subclass = this.classes[entityName];
      if (!Subclass) {
        objectClass = this._entityObjectClass(entity);
        Subclass = (function(superClass1) {
          extend(Subclass, superClass1);

          function Subclass() {
            return Subclass.__super__.constructor.apply(this, arguments);
          }

          return Subclass;

        })(objectClass);
        ref = entity.attributes;
        for (i = 0, len = ref.length; i < len; i++) {
          attribute = ref[i];
          Subclass.addAttributeDescription(attribute);
        }
        ref1 = entity.relationships;
        for (j = 0, len1 = ref1.length; j < len1; j++) {
          relationship = ref1[j];
          Subclass.addRelationshipDescription(relationship);
        }
        this.classes[entityName] = Subclass;
      }
      return Subclass;
    };

    ManagedObjectModel.prototype._entityObjectClass = function(entity) {
      var _m, cls, e, error, objectClassName;
      if (entity.objectClass) {
        return entity.objectClass;
      }
      objectClassName = entity.objectClassName;
      cls = null;
      if (objectClassName) {
        if (this.modelClasses[objectClassName]) {
          cls = this.modelClasses[objectClassName];
        } else {
          _m = module.parent;
          while (true) {
            try {
              cls = require(path.dirname(_m.filename) + objectClassName);
            } catch (error) {
              e = error;
            }
            _m = _m.parent;
            if (!_m) {
              break;
            }
          }
        }
      } else {
        cls = ManagedObject;
      }
      if (!cls) {
        throw new Error('module for class ' + entity.name + ' not found');
      }
      entity.objectClass = cls;
      return cls;
    };

    ManagedObjectModel.prototype.insertObjectIntoContext = function(entityName, context) {
      var Subclass, entity, object;
      entity = this.entities[entityName];
      if (!entity) {
        throw new Error('entity with name \'' + entityName + '\' doesn\'t exists');
      }
      Subclass = this.subclassForEntity(entityName);
      object = new Subclass(entity, context);
      object.entity = entity;
      context.insertObject(object);
      return object;
    };

    return ManagedObjectModel;

  })(Object);

  module.exports = ManagedObjectModel;

}).call(this);
